;******************************************************************************
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;    I (Simon Wood) can be contacted via email - unilink@mungewell.org
;    or via post - 14 Kirklands Close, Baildon, West Yorkshire, England.
;
;******************************************************************************

	TITLE           "GNU-link : CD-Multichanger Emulation"
	SUBTITLE        "Released under the GPL license, (c) S Wood, Oct 2001"

;******************************************************************************
;	Additional Info - Release version  1.8T_04
;		Modified Version : GNUnilink for MDX-5V101R
;			"Released under the GPL license, 
;					(c) H "Turboh" Ishimoto, 2004,2005"
;					   Email: ishimoto@bea.hi-ho.ne.jp
;******************************************************************************
; GNUnilink Configuration.
; Uncomment the lines relevant to your board... 
; this should be only configuration required.
;
; Type of PIC
;;#define		PIC_16F628
#define		PIC_16F648
;;#define		PIC_12F683

; Speed
;;--- Only "20MHz" is available.  (T)
#define		SPEED_20MHZ

;******************************************************************************
;;--- CD/MD manual setting		;; Feb. 21 2004  (T)
;;   If You want to select CD/MD mode by Hardware switch manually,
;;   Please Set Here.  (Comment out means Auto-select. default:MD)
	IFNDEF	PIC_12F683	;;(case PIC_12F683, this feature doesn't work.)

;;#define		CdMd_SW

	ENDIF	;;<NDEF	PIC_12F683>

;;-----------------------------------------------------
;;--- Next Disc 			;; Apr. 25 2004 (T)
;;   If You want to remap AS buttom to NextDisc,
;;   Please Set Here.  (Commentout means NOT to remap)
;;   (This function is espacially for MDX-5V101R with CD/MD changer)

#define		NextNext

;;-----------------------------------------------------
;;--- Internal_MD flag			;; Jul. 25 2004 (T)
;;   Priventing dongle to play followed by the internal MD.
;;   MDX-5V101R is able to handle one internal and one external
;;   MD chnager.  And HU automatically selects to play external 
;;   MD chnager followed by the end of playing by the internal one.
;;   When dongle emulates as an external MD chnager, if you do NOT 
;;   want this automatic selection, Please Set Here.

#define		Internal_MD

;;-----------------------------------------------------
;;--- DiscName_Scrol		;; Aug. 28 2004 (T)
;;   MDX-5V101R has no Auto-scrolling feature.
;;   To emulate pushing SCRL button, please set this flag on.
;;   (Attention: Button codes are not always the same in each HU.
;;    You should investigate your HU by reverse engineering.)

#define		DiscName_Scrol

;******************************************************************************
;;--- DEBUG Mode		;; Feb. 15 2004  (T)
				;; If you want to Release Version, 
;;#define	DEBUG			;; Comment Out This line.
				;;
;******************************************************************************
; Real settings for the PIC

		Radix   DEC
		EXPAND

	IFDEF	PIC_16F628
		Processor       16f628
		include         "p16f628.inc"

;; changed to WDT-OFF for TMR0 interrupt (T) 

	__CONFIG _CP_OFF & _PWRTE_ON & _HS_OSC & _WDT_OFF & _LVP_OFF

#define		PIC_16F62x
#define		PIC_16
	ENDIF

	IFDEF	PIC_16F648
		Processor       16f648a
		include         "p16f648a.inc"

	__CONFIG _CP_OFF & _PWRTE_ON & _HS_OSC & _WDT_OFF & _LVP_OFF

#define		PIC_16F62x
#define		PIC_16
	ENDIF

	IFDEF	PIC_12F683
		Processor       12f683
		include         "p12f683.inc"

	__CONFIG _FCMEN_OFF & _IESO_OFF & _BOD_ON & _CPD_OFF & _CP_OFF & _MCLRE_OFF & _PWRTE_ON & _WDT_OFF &  _HS_OSC
	ENDIF


	IFDEF	PIC_16
#define		OUT_PORT	PORTA
#define		OUT_ENA		TRISA
#define		CM_CONTL	CMCON
	ENDIF

	IFDEF	PIC_12F683
#define		OUT_PORT	GPIO
#define		OUT_ENA		TRISIO
#define		CM_CONTL	CMCON0
	ENDIF

;******************************************************************************
; A few standard definitions

_ResetVector	set	0x00
_IntVector      set     0x04

TRUE	equ	1
FALSE	equ	0

;******************************************************************************
; Timing Calibration Values - These are non critical in that they don't have 
; to be absolutely correct, but it's nicer to be almost right if you can....

; 100us delay loop is 8 + (n * 7) cycles.

;; Only SPEED_20MHZ should be available for the stability 
;; Baud rate should also be set higher rate, as possible. (T)

	IFDEF	SPEED_20MHZ
#define		delay100us	70
	ENDIF

;******************************************************************************
;                               Setup Register Locations
;; -------------- REGISTER BANK 0 ----- 0x20 - 0x6f ---------
Cmd1		set		0x20
Cmd2		set		0x21
Data11		set		0x22
Data12		set		0x23
Data13		set		0x24
Data14		set		0x25
Data21		set		0x26
Data22		set		0x27
Data23		set		0x28
Data24		set		0x29
Data25		set		0x2a
EndByte		set		0x2b
MyGroup		set		0x2c
Parity1		set		0x2d
Parity2		set		0x2e
Time0		set		0x2f
Time1		set		0x30
TrackNum	set		0x31
status_store	set		0x32	; stores STATUS reg during interrupt
w_store		set		0x33	; stores w reg during interrupt

;;---------Following Registers are added by Turboh ---------
Appoint_Now	set		0x34
Count3		set		0x35
DDir_Flag	set		0x36
DDir_Num	set		0x37
DSPL_Run	set		0x38
DSPL_ToggleC	set		0x39
DiscNamADDR	set		0x3a
DiscNam_DSPL	set		0x3b
Display		set		0x3c
DisplayMode	set		0x3d
DropCheckCount	set		0x3e
Dsp_Field	set		0x3f
EeRet		set		0x40
EepromChrAdd	set		0x41
Ej_announceF	set		0x42
GetMyG_Count	set		0x43
IdleState	set		0x44
Int1secON	set		0x45
Int1sec_Count	set		0x46
MD11State	set		0x47
MyIdCont_Flag	set		0x48
NeedToTalk	set		0x49
NewDiscNumP	set		0x4a
NewDiscNumR	set		0x4b
PCNT		set		0x4c
PCNT2		set		0x4d
PCNT3		set		0x4e
PowDown		set		0x4f
ResPeriod	set		0x50
SCRL_But	set		0x51
Sleeping	set		0x52
SlotOfMag	set		0x53
SlotOfMagP	set		0x54
SlotOfMg_Cd	set		0x55
SlotOfMg_Md	set		0x56
SubWork		set		0x57
SubWork2	set		0x58
TMR1H_SetData	set		0x59
TMR1L_SetData	set		0x5a
Tad		set		0x5b
Time0i		set		0x5c
Time1i		set		0x5d
Time1iT		set		0x5e
Timep		set		0x3f
TrackNamADDR	set		0x60
TrackNum_Tmp	set		0x61
PonReset_f	set		0x62
CnfChk_Count	set		0x63

;;---DEBUG
Test_Data	set		0x64		;; for DEBUG ;;
;;---

;; ---------- COMMON (shared) REGISTERS -- 0x70 - 0x7f ------
Checksum	set		0x70
Count		set		0x71
Count2		set		0x72
CurDiscNum	set		0x73
DataVal		set		0x74
DiskNum		set		0x75
DispCtrl	set		0x76
MyBit		set		0x77
MyId		set		0x78
Rad		set		0x79
TrackNum_Dsp	set		0x7a
CurSource	set		0x7b
ee_data		set		0x7c

;;--------------Following Values are added by Turboh ----------------
;; -- Please adjust for Your Hardware.
;; for TMR1 interrupt			;; May 22 2004 (T)
;;    Hardware Timer = 62610,  Software Timer = 10
;;	65536-62610=2926 = 0xb6e 	;; Adjusted May 29 2004 (T)

TMR1H_SetData	set		0x0b ;; TMR1H initial (=11)
TMR1L_SetData	set		0x6e ;; TMR1L initial (=110)
Int1sec_Data	set		0x0a ;; Software counter initial (=10)
;Int1sec_Data	set		0x01 ;; Software counter initial (=1)[DEBUG]
;Int1sec_Data	set		0x05 ;; Software counter initial (=5)[DEBUG]

;******************************************************************************
; Port definitions, which signal is where on the OUT_PORT

	IFDEF	PIC_16
#define		DataBit		0
#define		ClockBit	1
#define		BusOnBit	2
#define		CdNotMdBit	3
#define		LEDBit		3	;; Port_B    Feb.14 2004 (T)
#define		BusOnOut	4	;; Port_B    Nov.03 2004 (T)
#define		Rel_Set		5	;; Port_B    Apr.04 2004 (T)
	ENDIF

	IFDEF	PIC_12F683
#define		BusOnBit	1
#define		DataBit		2	;; (ST input)
#define 	ClockBit	3
#define 	LEDBit		0
	ENDIF

;******************************************************************************
;;--- Device ID
; Default definitions for responses, these may need to be changed for
; your HEADUNIT.

#define		MDX_61			;;MDX-61(MDX-5G01)
;#define	CDC1
;#define	MDC2

;;;;-----------------------------------------------
	IFDEF	MDX_61
Anyone_0	set		0x8c ;; MDX-61(MDX-5G01) (T)
Anyone_1	set		0x60
Anyone_2	set		0x06
Anyone_3	set		0x68
Anyone_4	set		0x02
Anyone_5	set		0x00

Appoint_0	set		0x8c ;; MDX-61(MDX-5G01) (T)
Appoint_1	set		0x60
Appoint_2	set		0x06
Appoint_3	set		0x68
Appoint_4	set		0x02
Appoint_5	set		0x00
	ENDIF
;;;;-----------------------------------------------
	IFDEF	CDC1
Anyone_0	set		0x8c ;; CDX-605, CDX-91 (by Mic)
Anyone_1	set		0xa0
Anyone_2	set		0x06
Anyone_3	set		0xab
Anyone_4	set		0x25
Anyone_5	set		0xa0

Appoint_0	set		0x8c
Appoint_1	set		0xa0
Appoint_2	set		0x06
Appoint_3	set		0xab
Appoint_4	set		0x25
Appoint_5	set		0xa0
	ENDIF

;******************************************************************************

DispCtrl_DcName	set		0x0d	;; display DiscName
DispCtrl_TrName	set		0x0f	;; display TrackName
DispCtrl_None	set		0x0c	;; display Nothing
DispCtrl_Inform	set		0x0e	;; Inform to HU (Not display Disc/Track names)

;******************************************************************************
;; -- DisplayMode
Show_Time	set		0x09	;; Display shows tracktime
Show_TrName	set		0x39	;; Display shows trackname
Show_DcName	set		0x19	;; Display shows disckname
Show_Clock	set		0x29	;; Display shows clock

;******************************************************************************
; Value of EEPROM ADDR for CD/MD MagInfoADDR (Slot of Magazine -1 )

MagCD_EEADR	set		0x10	;; EEPROM ADDR for Mag_CD(0x2110)
MagMD_EEADR	set		0x11	;; EEPROM ADDR for Mag_MD(0x2111)

;******************************************************************************
; Memorized value of MyGroup (CD or MD) in EEPROM
;  Controled by Next disc function

MyGroupEEADR	set		0x12	;; EEPROM ADDR for CD/MDgroup(0x2112)


;******************************************************************************
; Memorized value  of Display Mode in EEPROM

DsplMode_EEADR	set		0x13	;; EEPROM ADDR for Display Mode(0x2113)

;******************************************************************************
; Memorized value of toggle on DiscName in EEPROM

DsplTglC_EEADR	set		0x14	;; EEPROM ADDR for Toggle on Disc Name(0x2114)

;******************************************************************************
; Memorized value of EEPROM ADDR for DiscName and TrackName

DiscNamADDR0	set		0x20		;; EEPROM:0x2120
DiscNamADDR1	set		0x30		;; EEPROM:0x2130
TrackNamADDR0	set		0x40		;; EEPROM:0x2140
TrackNamADDR1	set		0x40		;; EEPROM:0x2140 (=ADDR0)

;******************************************************************************
; Start of code space

	ORG     _ResetVector
	goto	SystemSetup

;******************************************************************************
	include	"interrupt.asm"
	include	"functions.asm"
	include	"setup.asm"
	include	"receive.asm"
	include	"parse.asm"
	include	"respond.asm"
	include	"display.asm"

;******************************************************************************
; EEPROM data
	ORG     0x2100			;; hex version number
	DE	"050211sim20"
;; --- 0x2110 to  0x211f are reserved --- ;;
	ORG     0x2113
	DE	0x09			;; Display mode (Initial) 0x09(="Track Time")
	ORG	0x2114
	DE	0x00			;; DSPL_ToggkeC (Initial) 0x00
					;;           (="DiscNamADDR0")
;; -------------------------------------- ;;
	ORG	0x211a			;; 6 chars of SPACE
	DE	"      "		
	ORG     0x2120			;; Disk Name #1 
	DE	"<AUX-IN>        "	;;   (extra is the same with 6 chars back)
	ORG     0x2130			;; Disk Nmae #2 (extra is the same)
	DE	"VW-Maniacs      "	;;   (extra is the same with 6 chars back)
	ORG     0x2140			;; Track Name #1
	DE	"Not obsessed wit"
	ORG     0x2150			;; Track Name #1 (extra field #2, #3)
	DE	"h your VW?  That"
	ORG     0x2160			;; Track Name #1 (extra field #4, #5)
	DE	"'s OK, you are s"

	IFDEF	PIC_16F628		;; case PIC_16F628
	ORG     0x2170			;; Track Name #1 (extra field #6, #7)
	DE	"till welcome."

	ELSE				;; case PIC_16F648, 12F683 
	ORG     0x2170			;; Track Name #1 (extra field #6, #7)
	DE	"till welcome.   "
	ORG     0x2180			;; Track Name #1 (extra field #8, #9)
	DE	"- Volkswagen Man"
	ORG     0x2190			;; Track Name #1 (extra field #10)
	DE	"iacs - "
	ENDIF

;******************************************************************************

	END

