;******************************************************************************
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;    I (Simon Wood) can be contacted via email - unilink@mungewell.org
;    or via post - 14 Kirklands Close, Baildon, West Yorkshire, England.
;
;******************************************************************************
;	Additional Info - Release version  1.8T_04
;		Modified Version : GNUnilink for MDX-5V101R
;			"Released under the GPL license, 
;					(c) H "Turboh" Ishimoto, 2004,2005"
;					   Email: ishimoto@bea.hi-ho.ne.jp
;******************************************************************************
; Various responses to the commands
; These are clocked out by the master when it is ready
;******************************************************************************
Respond_Anyone:				;;  Feb. 14 2004 (T)
	movf	MyId, 1			; Test if we've got an ID
	btfsc	STATUS, Z
	goto	Respond_Anyone_main	;; (case MyId is Null) go get.

;;-- Even if MyId exists, case MyIdCont_Flag=1, you should renew your ID.

	btfss	MyIdCont_Flag, 0	;; check MyIdCont_Flag
	goto	ReceiveBreak		;; if MyIdCont_Flag=0, then Exit.

					;; if MyIdCont_Flag=1, 
	call	ResetBusOnOut		;; set BusOnOut=OFF  Apr. 11 2004 (T)

	clrf	MyId			;; and forget MyId,
	clrf	Appoint_Now		;; Not my turn. ;; Apr. 07 2004 (T)

	movlw	MyGroupEEADR		;; EEPROM(0x2112) data for GetMyGroup -> W
	call	Eeprom_Read		;; EEPROM read -> W
	xorlw	0x01			;; check value = 1 or not
	movlw	0xff			;; case NOT 0x01, set 0xff (next = MD mode)
	btfsc	STATUS, Z		;;
	movlw	0x01			;; case 0x01,  set 0x01 (next = CD mode)
	movwf	GetMyG_Count		;; set  GetMyG_Count

Respond_Anyone_main:
	call	ResetBusOnOut		;; set BusOnOut=OFF

	btfss	OUT_PORT, BusOnBit	; Test for BusOn being high
	goto	ReceiveBreak		;; (BusOn=OFF)

					;; (BusOn=ON)
	clrf	MyIdCont_Flag		;; clear MyIdCont_Flag

	clrf	Checksum 		; Clear checksum

	movlw	0x10			; 'I'm a .....'
	call	SendByte

	IFDEF	CdMd_SW			;; case Fixed by Hardware switch (T)
;;------------------------------------
	movf	MyGroup, 0
	call	SendByte
;;------------------------------------
	ELSE				;; case Automatic mode selection (T)
	call	GetMyGroup		;; return MyGroup --> W
	movwf	MyGroup			;; store W -> MyGroup
	call	SendByte
;;------------------------------------
	ENDIF ;;<CdMd_SW>

	call	Send_Anyone

	bsf	Appoint_Now,0		;; Set flag (It's My turn)


Respond_End:
	call	Respond_End_R

	goto	ReceiveBreak		; Done, wait for next command


Respond_End_R:				;; Return Type.
	movf	Checksum, 0		; Send Checksum
	call	SendByte
	
	movlw	0x00			;; 0x00: terminater
	call	SendByte

	return

Send_Anyone:
	movlw	Anyone_0
	call	SendByte

	movlw	Anyone_1
	call	SendByte

	call	Checksum_mid

	movlw	Anyone_2
	call	SendByte

	movlw	Anyone_3
	call	SendByte

	movlw	Anyone_4
	call	SendByte

	movlw	Anyone_5
	call	SendByte

	return

Respond_Appoint:
	btfss	Appoint_Now, 0		;; My turn ?

	goto	ReceiveBreak		;; (Not My turn) goto RB.
					;; (My turn) continue.
	movf	Rad, 0			; Store allocated ID
	movwf	MyId

	movf	Cmd2, 0			; Store bit position 
	movwf	MyBit			; (for SlavePoll response)

	clrf	MyIdCont_Flag		;; Feb. 14 2004 (T)

	clrf	Appoint_Now		;; Apr. 07 2004 (T)

Respond_App2:
	clrf	Checksum 		; Clear checksum

	movlw	0x10			; 'OK I'm ID=X'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movf	MyGroup, 0
	xorlw	0x30
	btfss	STATUS, Z		;; CD or MD?
	goto	Respond_App3		;; case MD

;;-- case CD
	movlw	Appoint_0		; different response
	call	SendByte

	movlw	Appoint_1
	call	SendByte

	call	Checksum_mid

	movlw	Appoint_2
	call	SendByte

	movlw	Appoint_3
	call	SendByte

	movlw	Appoint_4
	call	SendByte

	movlw	Appoint_5
	call	SendByte

	goto	App_RespEnd
	

Respond_App3:				;; added Apr. 11 2004 (T)
	call	Send_Anyone

	goto	App_RespEnd

App_RespEnd:
	call	Respond_End_R		

	call	SetBusOnOut		;; set BusOn_Out= High
	goto	ReceiveBreak		;;


Respond_Hello:				;; "Ping End"
;;--- Added ISB invoking 		Jan. 14 2004 (T)
;; If Display= 1,2,3,6,7,4,5,8,9,10,12,16,32 then call ISB_P3.
	call	LED_ON			;;

	incf	CnfChk_Count, 1		;; CnfChk_Count+1 -> CnfChk_Count

	IFDEF	DEBUG
;;---------------------------
	movlw	0x05			;; threshold(0x05) -> W	;; for Debug
	ELSE
	movlw	0x03			;; threshold(0x03) -> W
;;---------------------------
	ENDIF	;;<DEBUG>

	subwf	CnfChk_Count, 0		;; CnfChk_Count - 0x03 -> W

	btfsc	STATUS, C		;;
	goto	Respond_Hello2		;;(1:positive or zero) You've missed Me!!
					;;(0:negative) CnfChk_Count=1,2
	movf	MyId, 1			; Test for ID
	btfsc	STATUS, Z
	goto	Respond_Hello2		;; Not Me.

;;-- case Display=3
;; Add invoking ISB_P2 case Display=3 and Int1secON=1 .  Feb.02 2004  (T)
	movf	Display, 0
	xorlw	0x03		
	btfss	STATUS, Z		;; check if Display=3. 
	goto	Respond_Hello_ISB	;; Abort Display is not =3

	btfss	Int1secON, 0		;; Int1secON = ON(1)?

	goto	IssueSlaveBreak_P3	;; not Int1secON=1, goto ISB_P3

					;; case Display=3 & Int1secON=1
	clrf	Int1secON		;; clear flag
	call	IssueSlaveBreak

	goto	ReceiveBreak

Respond_Hello_ISB:
	movf	Display, 0		;; Display -> W
	andlw	0x0f			;; mask 0x0f
	xorlw	0x00			
	btfss	STATUS, Z		;; case Display=1 to 15,
	goto	IssueSlaveBreak_P2	;; then goto ISB_P3

	movf	Display, 0		;; Display -> W
	andlw	0xf0			;; mask 0xf0
	xorlw	0x00			
	btfss	STATUS, Z		;; case Display=16,32,48...,
	goto	IssueSlaveBreak_P2	;; then goto ISB_P3

	goto	ReceiveBreak		;; case Display=0, exit.


Respond_Hello2:
	call	SetBusOnOut		;; for the cascadesd slaves on Bus
					;; to be able to hear "re-initialize-bus"
					;; from HU.  (Oct. 14. 2004)

	clrf	Checksum 		; Clear checksum
	movlw	0x10			; 'You've missed me!!'
	call	SendByte

	movlw	0x18
	call	SendByte

	movlw	0x04
	call	SendByte

	movlw	0x00
	call	SendByte

	goto	Respond_End

Respond_Ping:
	movf	MyId, 0			; Check it's the right ID
					; MyId -> W
	xorwf	Rad, 0			;; 	Apr. 08 2004 (T)
	btfss	STATUS, Z

	goto	ReceiveBreak		;;

	bsf	MyIdCont_Flag,0 	;; set MyIdCont_Flag (Feb. 14 2004) (T)

	clrf	Checksum 		; Clear checksum

	movlw	0x10			; 'I'm playing'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0x00
	call	SendByte

;;-- Display 1,2,3,4,5,6,7 represent for "Playing"
;;-- and  0,16,32(=0x10,20) represent for  "Idle".
	movf	Display, 0
	andlw	0x0f			;; result -> W
	xorlw	0x00
	btfss	STATUS, Z
	goto	Pong_Playing		;; (1,2,3,4,5,6,7)

Pong_Idle:
;;-- add stete 'Pong-Ejecting'     	;;Jul 24 2004  (T)
	movf	IdleState, 0		;; load IdleState -> W
	call	SendByte

	goto	Respond_Ping3

Pong_Playing:
	movlw	0x00			; 'Playing'
	call	SendByte

Respond_Ping3:
	call	Respond_End_R
	call	LED_OFF			;;
	clrf	CnfChk_Count		;; 

	goto	ReceiveBreak		; wait for next command

IssueSlaveBreak_P3:			;; (Display = 3 Only)
	btfss	PowDown, 0		;; PowerDown state checking

	goto	ISB_Start3		;; (0):case PowerUp, Continue.
	call	Play_Stop		;; (1):case PowerDown, StopPlaying.
	goto	ReceiveBreak		;; goto RB.

ISB_Start3:				;; (Display = 3 Only)
	incf	DropCheckCount, 1 	;; DropChekCount+1
	movf	DropCheckCount, 0	;;
	sublw	0x02			;; Counter limit=8   Oct. 23 2004 (T)
					;; 0x04 - W -> W
	btfsc	STATUS, C		;; (0-4): C=1 (zero or positive)
					;; (over 5): C=0 (negative)
	goto	ReceiveBreak2		;; case C=1, goto RB

	IFDEF	DEBUG
;;-------------------------------
	incf	DiskNum, 0
	andlw	0x0f
	movwf	DiskNum
;;-------------------------------
	ENDIF

	movlw	0x03			;; case C=0 (negative)
	movwf	Display			;; set Display=3

	clrf	DropCheckCount		;;
	call	Int_Enaset		;; enable Interruput
	bsf	Int1secON, 0 		;; force set Int1secON=1

	goto	ReceiveBreak		;; goto	RB.


IssueSlaveBreak_P2:			;; ResPeriod force set. Apr. 18 2004 (T)
					;; (Do NOT use in Display=3)
	btfss	PowDown, 0		;; PowerDown state checking

	goto	ISB_Start2		;; (0):case PowerUp, Continue.
	call	Play_Stop		;; (1):case PowerDown, StopPlaying.
	goto	ReceiveBreak		;; goto RB.

ISB_Start2:
	bsf	ResPeriod, 0		;; set ResPeriod=1
	call	IssueSlaveBreak		;; call ISB

	goto	ReceiveBreak2		;; goto RB2


;;--- Response to Master Poll Command
Respond_MasterPoll:
	btfss	NeedToTalk, 0		;;Test wheather I need to talk

	goto	ReceiveBreak		;; case "OFF", abort	

	clrf	NeedToTalk
	clrf	ResPeriod		;; May 20 2004 (T)

	movf	Display, 0
	xorlw	0x00			; Test if we're active
	btfsc	STATUS, Z
	goto	ReceiveBreak		; wait for next command

	clrf	Checksum 		; Clear checksum

	movlw	0x10			; 'Something has changed!'
	call	SendByte

	movlw	0x18			; is to a broadcast address
	call	SendByte

	movlw	0x82
	call	SendByte

	movlw	0x00			; MyBit is 0x0? or 0x1?
	call	Bit_Frig
	call	SendByte

	call	Checksum_mid

	movlw	0x20			; MyBit is 0x2? or 0x3?
	call	Bit_Frig
	call	SendByte

	movlw	0x40			; MyBit is 0x4? or 0x5?
	call	Bit_Frig
	call	SendByte

	movlw	0x60			; MyBit is 0x6? or 0x7?
	call	Bit_Frig
	call	SendByte

	movlw	0x80			; MyBit is 0x8? or 0x9?
	call	Bit_Frig
	call	SendByte
	
	goto	Respond_End		; to do checksum and error byte


Respond_ReconfReq:			;; May 29 2004 (T)
	movf	MyId, 1			; Test if we've got an ID
	btfss	STATUS, Z
					;; case I've got MyId,
	goto	Respond_ReconfReq2	;; goto Reconfigure
	goto	ReceiveBreak		;; case NULL

Respond_ReconfReq2:
	incf	GetMyG_Count, 1		;; GetMyG_Count + 1 -> GetMyG_Count

;;-- store EEPROM 
	movlw	MyGroupEEADR	;; EEPROM(0x2112) data for GetMyGroup -> W
	call	Eeprom_Read	;; EEPROM read
	xorlw	0x01		;; check value = 1 or not
	movlw	0x01		;; case NOT 0x01, then switch to 0x01
	btfsc	STATUS, Z	;;
	movlw	0x00		;; case 0x01, then switch to 0x00
	movwf	ee_data		;; W -> EE_Data
	movlw	MyGroupEEADR	;; EEPROM(0x2112) data for GetMyGroup -> W
	call	Eeprom_Write	;; EEPROM write

;;-- send packet
	clrf	Checksum 		; Clear checksum
	movlw	0x10			; 'You've missed me!!'
	call	SendByte

	movlw	0x18
	call	SendByte

	movlw	0x04
	call	SendByte

	movlw	0x00
	call	SendByte

	call	Respond_End_R

	clrf	MyId			;;  MyId is force released

	goto	ReceiveBreak		; Done, wait for next command
					;; (Maybe reboot)

;******************************************************************************
;; --------End of respond.asm
